#include <iostream>
#include "mraa.hpp"

using namespace std;
using namespace mraa;

int main(void) {

	// Mostrar un mensaje de inicio
	cout << "Hello IOT2000." << endl;

	// Inicializar variables
	uint16_t value1;
	float value2;

	// Inicializar los pines de entrada y salida
	Gpio led_gpio(0);
	Aio pot_aio(0);

	// Definir el pin D0 como pin de salida
	led_gpio.dir(mraa::DIR_OUT);
	// Apagar el led en caso de estar encendido antes de la ejecucion del programa
	led_gpio.write(0);

	// Bucle del programa
	for (;;) {
			// Encender LED
			led_gpio.write(1);
			sleep(1);
			// Apagar LED
			led_gpio.write(0);
			sleep(1);
			// Leer la tension de entrada en el pin A0 (desde 0 hasta 1023)
			value1 = pot_aio.read();
			// Leer la tension de entrada en el pin A0 (desde 0 hasta 1)
			value2 = pot_aio.readFloat();
			// Mostrar dos mensajes con los valores leidos
			cout << "A0 read %d" << value1 << endl;
			cout << "A0 read %.5f" << value2 << endl;
			sleep(1);
	}

	return 0;
}

