#include <iostream>
#include "mraa.hpp"
#include "TinkerKit.hpp"

using namespace std;
using namespace mraa;

int main(void) {

	// Mostrar un mensaje de inicio
	cout << "Hello IOT2000." << endl;

	// Inicializar variables
	int pot_value;

	// Inicializar los pines de entrada y salida
	TKPotentiometer pot(I0);           // Potenciometro TinkerKit!
	TKLed led(O0);					   // Led TinkerKit!

	// Apagar el led en caso de estar encendido antes de la ejecucion del programa
	led.off();

	// Bucle del programa
	while (true) {
		pot_value = pot.read();         // Leer el valor ADC del potenciometro (de 0 a 1023)
		cout << "Potentiometer value: " << pot_value << endl; // Mostrar el valor leido
		if (led.state()) led.off();		// Led encendido, apagar
		else led.on();					// Led apagado, encender
		usleep(1000*1000);              // Esperar 1 segundo (10^6 ms) para la siguiente lectura
	}

	return 0;
}
