#include <iostream>
#include <stdio.h>

using namespace std;
using namespace mraa;

#define LED_ADDRESS 10

int main(void) {

	// Mostrar un mensaje de inicio
	cout << "Hello IOT2000." << endl;

	// Inicializar variables
	char buffer [3];
	uint16_t tab_reg[32];
	uint8_t dest[1];

	// Inicializar la conexion mediante TCP/IP
	modbus_t *mb;
	mb = modbus_new_tcp("192.168.1.40", MODBUS_TCP_DEFAULT_PORT);
	modbus_connect(mb);

	while (true) {
		modbus_read_bits(mb, LED_ADDRESS, 1, dest);				// Guardar el estado del led del esclavo en 'dest'
		if (dest) modbus_write_bit(mb, LED_ADDRESS, FALSE);		// El led esta encendido, apagarlo
		else modbus_write_bit(mb, LED_ADDRESS, TRUE);			// El led esta apagado, encenderlo
		modbus_read_input_registers(mb, 0, 3, tab_reg);				// Leer el valor de los potenciometros del esclavo
		sprintf(buffer, "POT1: %d; POT2: %d; POT3: %d", tab_reg);	// Crear un array con caracteres con los valores leidos
		cout << "Potentiometer values: " << buffer << endl;		// Enviar un mensaje con los valores leidos
		sleep(1);
	}

	// Cerrar la conexion
	modbus_close(mb);
	modbus_free(mb);

	return 0;
}

