#include <iostream>
#include <stdio.h>

using namespace std;
using namespace mraa;

int main(void) {

	// Mostrar un mensaje de inicio
	cout << "Hello IOT2000." << endl;

	modbus_mapping_t *mapping = modbus_mapping_new(1, 0, 3, 0);
	if (!mapping) {
		// No se ha podido guardar la tabla de registros en la memoria
	    spritnf(stderr, "Failed to allocate the mapping: %s\n", modbus_strerror(errno));
	    exit(1);
	}

	//Example: set register 12 to integer value 623
	mapping->tab_registers[12] = 623;

	// Inicializar variables
	uint8_t req[MODBUS_TCP_MAX_ADU_LENGTH];
	int len;


	// Inicializar la conexion mediante TCP/IP
	modbus_t *mb;
	mb = modbus_new_tcp("192.168.1.40", MODBUS_TCP_DEFAULT_PORT);
	modbus_connect(mb);

	while(1) {
	    len = modbus_receive(ctx, req);			// Recibir las peticiones
	    if (len == -1) break;					// En caso de error, salir
	    len = modbus_reply(ctx, req, len, mapping);		// Responder a las peticiones
	    if (len == -1) break;					// En caso de error, salir
	}
	cout << "Error during transmission" << endl;

	// Cerrar la conexion
	modbus_close(mb);
	modbus_free(mb);

	return 0;
}
